<?php
/**
 * -----------------------------------------------------------------------------
 *
 * SyL - Web Application Framework for PHP
 *
 * PHP version 4 (>= 4.3.x) or 5
 *
 * Copyright (C) 2006 k.watanabe
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -----------------------------------------------------------------------------
 * @package   SyL
 * @author    k.watanabe <k.watanabe@syl.jp>
 * @copyright 2006 k.watanabe
 * @license   http://www.opensource.org/licenses/lgpl-license.php
 * @version   CVS: $Id: SyL_XMLParser.php,v 1.8 2007/01/03 11:17:37 seasonstream Exp $
 * @link      http://www.syl.jp/
 * -----------------------------------------------------------------------------
 */

if (!defined('SYL_XML_ENCODE')) {
    define('SYL_XML_ENCODE', 'UTF-8');
}

/**
 *  XMLパーサークラス
 *
 * @package   SyL
 * @author    k.watanabe <k.watanabe@syl.jp>
 * @copyright 2006 k.watanabe
 * @license   http://www.opensource.org/licenses/lgpl-license.php
 * @version   CVS: $Id: SyL_XMLParser.php,v 1.8 2007/01/03 11:17:37 seasonstream Exp $
 * @link      http://www.syl.jp/
 */
class SyL_XMLParser
{
    /**
     * ファイルパス（URLでもOK）
     *
     * @access private
     * @var string
     */
    var $file_name = '';
    /**
     * XML文字コード
     *
     * @access private
     * @var string
     */
    var $xml_encode = SYL_XML_ENCODE;

    /**
     * コンストラクタ
     *
     * @access public
     * @param string XMLファイル名
     */
    function SyL_XMLParser($file_name)
    {
        $this->setFile($file_name);
    }

    /**
     * XMLファイルをセット
     *
     * @access public
     * @param int ストリーム取得サイズ
     */
    function setFile($file_name)
    {
        if (!file_exists($file_name)) {
            trigger_error("[SyL error] Xml file not found ({$file_name})", E_USER_ERROR);
        }
        $this->file_name = $file_name;
    }

    /**
     * XMLファイルの解析処理
     *
     * @access private
     */
    function parseXML()
    {
        // XMLパーサー作成 文字コードUTF-8
        $parser = xml_parser_create($this->xml_encode);
        // 大文字変換を行わない
        xml_parser_set_option($parser, XML_OPTION_CASE_FOLDING, false);
        // ハンドラメソッドをクラスメソッドに設定
        xml_set_object($parser, &$this);
        // start および end 要素のハンドラを設定する
        xml_set_element_handler( $parser,
          array(&$this, 'startElement'),
          array(&$this, 'endElement'  )
        );
        // 文字データハンドラを設定する
        xml_set_character_data_handler($parser, array(&$this, 'characters'));

        // XMLファイルオープン
        if (($fp = @fopen($this->file_name, 'r')) == false) {
            trigger_error("[SyL error] Can't open xml file({$this->file_name})", E_USER_ERROR);
        } else {
            $file_size = filesize($this->file_name);
            // 読み込みと解析
            while ($data = fread($fp, $file_size)) {
                // XMLパース処理
                if (!xml_parse($parser, $data, feof($fp))){
                    // パースエラー処理
                    trigger_error(
                      sprintf("[SyL error] XML parse error: %s at %s (%d)",
                        xml_error_string(xml_get_error_code($parser)),
                        $this->file_name,
                        xml_get_current_line_number($parser)
                      ),
                      E_USER_ERROR
                    );
                }
            }
            // XMLファイルクローズ
            fclose($fp);
        }
        // XMLパーサの開放 
        xml_parser_free($parser);
    }

    /**
     * エレメント開始の実行処理
     *
     * @access public
     * @param resource XMLパーサー
     * @param string エレメント名
     * @param array エレメントの属性配列
     */
    function startElement(&$parser, $name, $attr) {}

    /**
     * エレメント終了の実行処理
     *
     * @access public
     * @param resource XMLパーサー
     * @param string エレメント名
     */
    function endElement(&$parser, $name) {}

    /**
     * キャラクタエレメントの実行処理
     *
     * @access public
     * @param resource XMLパーサー
     * @param string 文字列
     */
    function characters(&$parser, $text) {}
}

?>
